<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Models;
use Carbon\Carbon;
use App\Http\Base\BaseModel;

class RolesModel extends BaseModel
{
    /**
     * table name from database
     */
    protected $table = "roles";

    /**
     *   alias table for relation issues
     */
    protected $aliasTable = "roles";

    /**
     * primary key from table remember eloquent doesnt support composite primary key
     */
    protected $primaryKey = "id";
    /**
     * fillable property for eloquent attribute cast
     */
    protected $fillable = [
        "id", "roleName", "date_updated"
    ];
    /**
     * Creating raw object from table that, this purpose for making you easier for remembering all attribute
     */


    /**
     * paging for default paging purpose
     * if you want to add new paging property you have to add the property in this array
     * you have to add the relation value
     * remember this is not suported casting value you have to handle by your self
     */
    protected $aliasPaging = [
        "id" => "roles.id",
        "roleName" => "roles.roleName",
    ];

    /**
     * relation from ' . approver . ' by ' . roleId
     * join approver on approver.id = roles.roleId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationApproverRoleId($alias = "approver")
    {
        $this->getQuery()->join("approver as $alias", "$alias.roleId", "=", "roles.id");
        return $this;
    }

    /**
     * relation from ' . users . ' by ' . roleId
     * join users on users.id = roles.roleId
     * this join use inner join if you want to change to left or right join or you want add some callback  you may refer to eloquent documentation
     * but you do like this $this->>getQuery()->leftJoin(function($query){}) we use query builder for our model
     * @param string $alias
     * @return $this
     */
    public function joinRelationUsersRoleId($alias = "users")
    {
        $this->getQuery()->join("users as $alias", "$alias.roleId", "=", "roles.id");
        return $this;
    }

    public static function storeFromHO($data)
    {

        $model = (new self())->getQuery()->where("roles.id", "=", $data->id)->first();
        if ($model) {
            $model = self::find($model->id);
            $model->id = $data->id;
            $model->roleName = $data->roleName;
            $model->date_updated = $data->date_updated;
            $model->update();
            (new LogsynckapalModel)->setLogSync("Roles : ".$data->id." - ".$data->roleName, Carbon::now()->toDateTimeString(), "", "updated");
        } else {
            $model = new self();
            $model->id = $data->id;
            $model->roleName = $data->roleName;
            $model->date_updated = $data->date_updated;
            $model->save([], $data->id, 0);
            (new LogsynckapalModel)->setLogSync("Roles : ".$data->id." - ".$data->roleName, Carbon::now()->toDateTimeString(), "", "inserted");
        }
        echo $data->roleName . " sync", PHP_EOL;
    }

    public static function getRole()
    {
        $url = $GLOBALS["env"]["HEAD_OFFICE_URL"] . "/api/sync_roles";
        $syncTable = (new \App\Http\Models\SyncUtilities\SyncTableHandlerModel())->getQuery()->where("sync_table.id", "=", 7)->first();
        $fetch = true;
        $page = 1;
        (new LogsynckapalModel)->setLogSync("Roles HO to Kapal", Carbon::now()->toDateTimeString(), "", "start");
        do {
            if ($syncTable) {

                $lastUpdate = Carbon::parse($syncTable->last_sync)->toAtomString();
                $lastUpdate = !empty($syncTable->last_sync) ? \Carbon\Carbon::parse($syncTable->last_sync)->toAtomString() : $lastUpdate;
                $url = $url . "?date_updated=" . $lastUpdate . "&page=" . $page;
                $syncHandler = new \App\Http\Handler\CurlHandler();
                try {
                    $response = $syncHandler->setUrl($url)->send();
                    $res = json_decode($response, false);
                    $no = 1;
                    if (!empty($res->data)) {
                        if($page == 1) {
                            \App\Http\Models\RolesModel::truncate();
                        }
                        foreach ($res->data as $item) {
                            echo "data " . $no;
                            \App\Http\Models\RolesModel::storeFromHO($item);
                            $lastUpdate = $item->date_updated;
                            $no = $no + 1;
                        }
                        $sync = \App\Http\Models\SyncUtilities\SyncTableHandlerModel::find($syncTable->id);
                        $sync->last_sync = $lastUpdate;
                        $sync->update();
                    } else $fetch = false;

                } catch (\Exception $e) {
                    echo $e->getMessage();
                    (new LogsynckapalModel)->setLogSync("Roles HO to Kapal", Carbon::now()->toDateTimeString(), $e->getMessage(), "failed");
                }
                $page = $page + 1;
            }
        } while ($fetch);
        (new LogsynckapalModel)->setLogSync("Roles HO to Kapal", Carbon::now()->toDateTimeString(), "", "success");
    }
}